Index: branches/ScatterSearch/HeuristicLab.Algorithms.ScatterSearch/3.3/ScatterSearch.cs
===================================================================
--- branches/ScatterSearch/HeuristicLab.Algorithms.ScatterSearch/3.3/ScatterSearch.cs	(revision 7774)
+++ branches/ScatterSearch/HeuristicLab.Algorithms.ScatterSearch/3.3/ScatterSearch.cs	(revision 7775)
@@ -306,6 +306,10 @@
       ICrossover defaultCrossover = Problem.Operators.OfType<ICrossover>().FirstOrDefault();
 
+      CrossoverParameter.ValidValues.Add(new Knapsack.KnapsackPathRelinker());
+      CrossoverParameter.ValidValues.Add(new Knapsack.KnapsackSimultaneousPathRelinker());
+      CrossoverParameter.ValidValues.Add(new TestFunctions.TestFunctionsPathRelinker());
       CrossoverParameter.ValidValues.Add(new TravelingSalesman.TravelingSalesmanPathRelinker());
-      CrossoverParameter.ValidValues.Add(new Knapsack.KnapsackPathRelinker());
+      CrossoverParameter.ValidValues.Add(new TravelingSalesman.TravelingSalesmanSimultaneousPathRelinker());
+      CrossoverParameter.ValidValues.Add(new TravelingSalesman.TravelingSalesmanMultipleGuidesPathRelinker());
 
       foreach (ICrossover crossover in Problem.Operators.OfType<ICrossover>().OrderBy(x => x.Name))
@@ -329,4 +333,5 @@
 
       DiversityCalculatorParameter.ValidValues.Add(new Knapsack.BinaryVectorDiversityCalculator());
+      DiversityCalculatorParameter.ValidValues.Add(new TestFunctions.RealVectorDiversityCalculator());
       DiversityCalculatorParameter.ValidValues.Add(new TravelingSalesman.PermutationDiversityCalculator());
 
@@ -348,4 +353,14 @@
 
       ImproverParameter.ValidValues.Add(new Knapsack.KnapsackImprovementOperator());
+      ImproverParameter.ValidValues.Add(new TestFunctions.TestFunctionsAckleyImprovementOperator());
+      ImproverParameter.ValidValues.Add(new TestFunctions.TestFunctionsBealeImprovementOperator());
+      ImproverParameter.ValidValues.Add(new TestFunctions.TestFunctionsBoothImprovementOperator());
+      ImproverParameter.ValidValues.Add(new TestFunctions.TestFunctionsGriewankImprovementOperator());
+      ImproverParameter.ValidValues.Add(new TestFunctions.TestFunctionsLevyImprovementOperator());
+      ImproverParameter.ValidValues.Add(new TestFunctions.TestFunctionsMatyasImprovementOperator());
+      ImproverParameter.ValidValues.Add(new TestFunctions.TestFunctionsRosenbrockImprovementOperator());
+      ImproverParameter.ValidValues.Add(new TestFunctions.TestFunctionsSchwefelImprovementOperator());
+      ImproverParameter.ValidValues.Add(new TestFunctions.TestFunctionsSumSquaresImprovementOperator());
+      ImproverParameter.ValidValues.Add(new TestFunctions.TestFunctionsZakharovImprovementOperator());
       ImproverParameter.ValidValues.Add(new TravelingSalesman.TravelingSalesmanImprovementOperator());
 
Index: branches/ScatterSearch/HeuristicLab.Algorithms.ScatterSearch/3.3/ScatterSearchMainLoop.cs
===================================================================
--- branches/ScatterSearch/HeuristicLab.Algorithms.ScatterSearch/3.3/ScatterSearchMainLoop.cs	(revision 7774)
+++ branches/ScatterSearch/HeuristicLab.Algorithms.ScatterSearch/3.3/ScatterSearchMainLoop.cs	(revision 7775)
@@ -33,5 +33,5 @@
   /// An operator which represents a scatter search.
   /// </summary>
-  [Item("ScatterSearchMainLoop", "An operator which represents the main loop of a scatter search.")]
+  [Item("ScatterSearchMainLoop", "An operator which represents a scatter search.")]
   [StorableClass]
   public sealed class ScatterSearchMainLoop : AlgorithmOperator {
Index: branches/ScatterSearch/HeuristicLab.Algorithms.ScatterSearch/3.3/SolutionPool2TierUpdateMethod.cs
===================================================================
--- branches/ScatterSearch/HeuristicLab.Algorithms.ScatterSearch/3.3/SolutionPool2TierUpdateMethod.cs	(revision 7775)
+++ branches/ScatterSearch/HeuristicLab.Algorithms.ScatterSearch/3.3/SolutionPool2TierUpdateMethod.cs	(revision 7775)
@@ -0,0 +1,206 @@
+﻿#region License Information
+/* HeuristicLab
+ * Copyright (C) 2002-2012 Heuristic and Evolutionary Algorithms Laboratory (HEAL)
+ *
+ * This file is part of HeuristicLab.
+ *
+ * HeuristicLab is free software: you can redistribute it and/or modify
+ * it under the terms of the GNU General Public License as published by
+ * the Free Software Foundation, either version 3 of the License, or
+ * (at your option) any later version.
+ *
+ * HeuristicLab is distributed in the hope that it will be useful,
+ * but WITHOUT ANY WARRANTY; without even the implied warranty of
+ * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
+ * GNU General Public License for more details.
+ *
+ * You should have received a copy of the GNU General Public License
+ * along with HeuristicLab. If not, see <http://www.gnu.org/licenses/>.
+ */
+#endregion
+
+using System;
+using System.Collections.Generic;
+using System.Linq;
+using HeuristicLab.Common;
+using HeuristicLab.Core;
+using HeuristicLab.Data;
+using HeuristicLab.Operators;
+using HeuristicLab.Parameters;
+using HeuristicLab.Persistence.Default.CompositeSerializers.Storable;
+
+namespace HeuristicLab.Algorithms.ScatterSearch {
+  /// <summary>
+  /// An operator that updates the solution pool using a 2-tier strategy.
+  /// </summary>
+  [Item("SolutionPool2TierUpdateMethod", "An operator that updates the solution pool using a 2-tier strategy.")]
+  [StorableClass]
+  public sealed class SolutionPool2TierUpdateMethod : SingleSuccessorOperator, IScatterSearchTargetProcessor {
+    #region Parameter properties
+    public ScopeParameter CurrentScopeParameter {
+      get { return (ScopeParameter)Parameters["CurrentScope"]; }
+    }
+    public IValueLookupParameter<DiversityCalculator> DiversityCalculatorParameter {
+      get { return (IValueLookupParameter<DiversityCalculator>)Parameters["DiversityCalculator"]; }
+    }
+    public IValueLookupParameter<BoolValue> MaximizationParameter {
+      get { return (IValueLookupParameter<BoolValue>)Parameters["Maximization"]; }
+    }
+    public IValueLookupParameter<BoolValue> NewSolutionsParameter {
+      get { return (IValueLookupParameter<BoolValue>)Parameters["NewSolutions"]; }
+    }
+    public IValueLookupParameter<IntValue> NumberOfHighQualitySolutionsParameter {
+      get { return (IValueLookupParameter<IntValue>)Parameters["NumberOfHighQualitySolutions"]; }
+    }
+    public IValueLookupParameter<IntValue> ReferenceSetSizeParameter {
+      get { return (IValueLookupParameter<IntValue>)Parameters["ReferenceSetSize"]; }
+    }
+    public IValueLookupParameter<IItem> QualityParameter {
+      get { return (IValueLookupParameter<IItem>)Parameters["Quality"]; }
+    }
+    public IValueLookupParameter<IItem> TargetParameter {
+      get { return (IValueLookupParameter<IItem>)Parameters["Target"]; }
+    }
+    #endregion
+
+    #region Properties
+    private IScope CurrentScope {
+      get { return CurrentScopeParameter.ActualValue; }
+    }
+    private DiversityCalculator DiversityCalculator {
+      get { return DiversityCalculatorParameter.ActualValue; }
+    }
+    private BoolValue Maximization {
+      get { return MaximizationParameter.ActualValue; }
+      set { MaximizationParameter.ActualValue = value; }
+    }
+    private BoolValue NewSolutions {
+      get { return NewSolutionsParameter.ActualValue; }
+    }
+    private IntValue NumberOfHighQualitySolutions {
+      get { return NumberOfHighQualitySolutionsParameter.ActualValue; }
+    }
+    private IntValue ReferenceSetSize {
+      get { return ReferenceSetSizeParameter.ActualValue; }
+      set { ReferenceSetSizeParameter.ActualValue = value; }
+    }
+    private IItem Quality {
+      get { return QualityParameter.ActualValue; }
+    }
+    private IItem Target {
+      get { return TargetParameter.ActualValue; }
+    }
+    #endregion
+
+    [StorableConstructor]
+    private SolutionPool2TierUpdateMethod(bool deserializing) : base(deserializing) { }
+    private SolutionPool2TierUpdateMethod(SolutionPool2TierUpdateMethod original, Cloner cloner) : base(original, cloner) { }
+    public SolutionPool2TierUpdateMethod() : base() { Initialize(); }
+
+    public override IDeepCloneable Clone(Cloner cloner) {
+      return new SolutionPool2TierUpdateMethod(this, cloner);
+    }
+
+    private void Initialize() {
+      #region Create parameters
+      Parameters.Add(new ScopeParameter("CurrentScope"));
+      Parameters.Add(new ValueLookupParameter<DiversityCalculator>("DiversityCalculator"));
+      Parameters.Add(new ValueLookupParameter<BoolValue>("Maximization"));
+      Parameters.Add(new ValueLookupParameter<BoolValue>("NewSolutions"));
+      Parameters.Add(new ValueLookupParameter<IntValue>("NumberOfHighQualitySolutions"));
+      Parameters.Add(new ValueLookupParameter<IntValue>("ReferenceSetSize"));
+      Parameters.Add(new ValueLookupParameter<IItem>("Quality"));
+      Parameters.Add(new ValueLookupParameter<IItem>("Target"));
+      #endregion
+      TargetParameter.ActualName = "KnapsackSolution"; // temporary solution for the knapsack problem
+    }
+
+    public override IOperation Apply() {
+      var parentsScope = new Scope("Parents");
+      var offspringScope = new Scope("Offspring");
+
+      // split parents and offspring
+      foreach (var scope in CurrentScope.SubScopes) {
+        parentsScope.SubScopes.AddRange(scope.SubScopes.Take(scope.SubScopes.Count - 1));
+        offspringScope.SubScopes.AddRange(scope.SubScopes.Last().SubScopes);
+      }
+
+      var orderedParents = Maximization.Value ? parentsScope.SubScopes.OrderByDescending(x => x.Variables[QualityParameter.ActualName].Value) :
+                                                parentsScope.SubScopes.OrderBy(x => x.Variables[QualityParameter.ActualName].Value);
+      var orderedOffspring = Maximization.Value ? offspringScope.SubScopes.OrderByDescending(x => x.Variables[QualityParameter.ActualName].Value) :
+                                                  offspringScope.SubScopes.OrderBy(x => x.Variables[QualityParameter.ActualName].Value);
+
+      var highQualityParents = orderedParents.Take(NumberOfHighQualitySolutions.Value).ToList();
+      var highDiversityParents = new List<Tuple<IScope, double>>();
+      foreach (var oScope in orderedParents.Skip(NumberOfHighQualitySolutions.Value)) {
+        double diversity = 0.0;
+        var oSol = oScope.Variables[TargetParameter.ActualName].Value;
+        foreach (var hScope in highQualityParents) {
+          var hSol = hScope.Variables[TargetParameter.ActualName].Value;
+          diversity += DiversityCalculator.ExecuteCalculation(oSol, hSol);
+        }
+        highDiversityParents.Add(new Tuple<IScope, double>(oScope, diversity));
+      }
+
+      var offspring = new List<Tuple<IScope, double>>();
+      foreach (var oScope in orderedOffspring) {
+        double diversity = 0.0;
+        var oSol = oScope.Variables[TargetParameter.ActualName].Value;
+        foreach (var hScope in highQualityParents) {
+          var hSol = hScope.Variables[TargetParameter.ActualName].Value;
+          diversity += DiversityCalculator.ExecuteCalculation(oSol, hSol);
+        }
+        offspring.Add(new Tuple<IScope, double>(oScope, diversity));
+      }
+
+      // update high quality part of the reference set
+      var hasBetterQuality = Maximization.Value ? (Func<Tuple<IScope, double>, bool>)(x => { return (x.Item1.Variables[QualityParameter.ActualName].Value as DoubleValue).Value > (highQualityParents.OrderBy(y => y.Variables[QualityParameter.ActualName].Value).First().Variables[QualityParameter.ActualName].Value as DoubleValue).Value; }) :
+                                                  (Func<Tuple<IScope, double>, bool>)(x => { return (x.Item1.Variables[QualityParameter.ActualName].Value as DoubleValue).Value < (highQualityParents.OrderByDescending(y => y.Variables[QualityParameter.ActualName].Value).First().Variables[QualityParameter.ActualName].Value as DoubleValue).Value; });
+      if (offspring.Any(hasBetterQuality)) NewSolutions.Value = true;
+      while (offspring.Any(hasBetterQuality)) { // better offspring available
+        // select best offspring
+        var bestChild = Maximization.Value ? offspring.OrderByDescending(x => x.Item1.Variables[QualityParameter.ActualName].Value).First() :
+                                             offspring.OrderBy(x => x.Item1.Variables[QualityParameter.ActualName].Value).First();
+        // select worst parent
+        var worstParent = Maximization.Value ? highQualityParents.OrderByDescending(x => x.Variables[QualityParameter.ActualName].Value).Last() :
+                                               highQualityParents.OrderBy(x => x.Variables[QualityParameter.ActualName].Value).Last();
+        highQualityParents.Remove(worstParent);
+        highQualityParents.Add(bestChild.Item1);
+        offspring.Remove(bestChild);
+      }
+
+      // update diversity part of the reference set
+      var hasBetterDiversity = (Func<Tuple<IScope, double>, bool>)(x => { return x.Item2 > highDiversityParents.OrderBy(y => y.Item2).First().Item2; });
+      if (offspring.Any(hasBetterDiversity)) NewSolutions.Value = true;
+      while (offspring.Any(hasBetterDiversity)) { // better offspring available
+        // select best offspring
+        var bestChild = offspring.OrderByDescending(x => x.Item2).First();
+        // select worst parent
+        var worstParent = highDiversityParents.OrderBy(x => x.Item2).First();
+        highDiversityParents.Remove(worstParent);
+        highDiversityParents.Add(bestChild);
+        offspring.Remove(bestChild);
+      }
+
+      CurrentScope.SubScopes.Replace(highQualityParents.Concat(highDiversityParents.Select(x => x.Item1)).ToList());
+
+      return base.Apply();
+    }
+
+    private class KeyEqualityComparer<T> : IEqualityComparer<T> {
+      private readonly Func<T, object> keyExtractor;
+
+      public KeyEqualityComparer(Func<T, object> keyExtractor) {
+        this.keyExtractor = keyExtractor;
+      }
+
+      public bool Equals(T x, T y) {
+        return keyExtractor(x).Equals(keyExtractor(y));
+      }
+
+      public int GetHashCode(T obj) {
+        return keyExtractor(obj).GetHashCode();
+      }
+    }
+  }
+}
Index: branches/ScatterSearch/HeuristicLab.Algorithms.ScatterSearch/3.3/SolutionPoolUpdateMethod.cs
===================================================================
--- branches/ScatterSearch/HeuristicLab.Algorithms.ScatterSearch/3.3/SolutionPoolUpdateMethod.cs	(revision 7774)
+++ branches/ScatterSearch/HeuristicLab.Algorithms.ScatterSearch/3.3/SolutionPoolUpdateMethod.cs	(revision 7775)
@@ -123,13 +123,13 @@
       var worstParentQuality = (orderedParents.Last().Variables[QualityParameter.ActualName].Value as DoubleValue).Value;
 
-      var Constraint = Maximization.Value ? (Func<IScope, bool>)(x => { return (x.Variables[QualityParameter.ActualName].Value as DoubleValue).Value > worstParentQuality; }) :
+      var hasBetterQuality = Maximization.Value ? (Func<IScope, bool>)(x => { return (x.Variables[QualityParameter.ActualName].Value as DoubleValue).Value > worstParentQuality; }) :
                                             (Func<IScope, bool>)(x => { return (x.Variables[QualityParameter.ActualName].Value as DoubleValue).Value < worstParentQuality; });
 
       // is there any offspring better than the worst parent?
-      if (orderedOffspring.Any(Constraint)) {
+      if (orderedOffspring.Any(hasBetterQuality)) {
         // produce the set union
         // attention: distinction might cause a too small reference set! (e.g. reference set = {1, 2, 2, 2, ..., 2} -> union = {1, 2}
-        var union = orderedParents.Union(orderedOffspring.Where(Constraint), new KeyEqualityComparer<IScope>(x => x.Variables[TargetParameter.ActualName].Value.ToString()));
-        if (union.Count() > orderedParents./*Distinct(new KeyEqualityComparer<IScope>(x => x.Variables[TargetParameter.ActualName].Value.ToString())).*/Count()) {
+        var union = orderedParents.Union(orderedOffspring.Where(hasBetterQuality), new KeyEqualityComparer<IScope>(x => x.Variables[TargetParameter.ActualName].Value.ToString()));
+        if (union.Count() > orderedParents/*.Distinct(new KeyEqualityComparer<IScope>(x => x.Variables[TargetParameter.ActualName].Value.ToString()))*/.Count()) {
           var orderedUnion = Maximization.Value ? union.OrderByDescending(x => x.Variables[QualityParameter.ActualName].Value) :
                                                   union.OrderBy(x => x.Variables[QualityParameter.ActualName].Value);
Index: branches/ScatterSearch/HeuristicLab.Algorithms.ScatterSearch/3.3/TestFunctions/RealVectorDiversityCalculator.cs
===================================================================
--- branches/ScatterSearch/HeuristicLab.Algorithms.ScatterSearch/3.3/TestFunctions/RealVectorDiversityCalculator.cs	(revision 7775)
+++ branches/ScatterSearch/HeuristicLab.Algorithms.ScatterSearch/3.3/TestFunctions/RealVectorDiversityCalculator.cs	(revision 7775)
@@ -0,0 +1,56 @@
+﻿#region License Information
+/* HeuristicLab
+ * Copyright (C) 2002-2012 Heuristic and Evolutionary Algorithms Laboratory (HEAL)
+ *
+ * This file is part of HeuristicLab.
+ *
+ * HeuristicLab is free software: you can redistribute it and/or modify
+ * it under the terms of the GNU General Public License as published by
+ * the Free Software Foundation, either version 3 of the License, or
+ * (at your option) any later version.
+ *
+ * HeuristicLab is distributed in the hope that it will be useful,
+ * but WITHOUT ANY WARRANTY; without even the implied warranty of
+ * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
+ * GNU General Public License for more details.
+ *
+ * You should have received a copy of the GNU General Public License
+ * along with HeuristicLab. If not, see <http://www.gnu.org/licenses/>.
+ */
+#endregion
+
+using System;
+using HeuristicLab.Common;
+using HeuristicLab.Core;
+using HeuristicLab.Encodings.RealVectorEncoding;
+using HeuristicLab.Persistence.Default.CompositeSerializers.Storable;
+
+namespace HeuristicLab.Algorithms.ScatterSearch.TestFunctions {
+  /// <summary>
+  /// An operator that performs diversity calculation between real vectors.
+  /// </summary>
+  [Item("RealVectorDiversityCalculator", "An operator that performs diversity calculation between real vectors.")]
+  [StorableClass]
+  public sealed class RealVectorDiversityCalculator : DiversityCalculator {
+    [StorableConstructor]
+    private RealVectorDiversityCalculator(bool deserializing) : base(deserializing) { }
+    private RealVectorDiversityCalculator(RealVectorDiversityCalculator original, Cloner cloner) : base(original, cloner) { }
+    public RealVectorDiversityCalculator() : base() { }
+
+    public override IDeepCloneable Clone(Cloner cloner) {
+      return new RealVectorDiversityCalculator(this, cloner);
+    }
+
+    protected override double CalculateDiversity(IItem left, IItem right) {
+      if (!(left is RealVector) || !(right is RealVector))
+        throw new ArgumentException("Cannot calculate diversity because one of the provided objects or both have the wrong type.");
+
+      var v1 = left as RealVector;
+      var v2 = right as RealVector;
+      double sum = 0.0;
+      for (int i = 0; i < v1.Length; i++)
+        sum += Math.Pow(v1[i] - v2[i], 2);
+      return Math.Sqrt(sum);
+    }
+  }
+}
Index: branches/ScatterSearch/HeuristicLab.Algorithms.ScatterSearch/3.3/TestFunctions/TestFunctionsAckleyImprovementOperator.cs
===================================================================
--- branches/ScatterSearch/HeuristicLab.Algorithms.ScatterSearch/3.3/TestFunctions/TestFunctionsAckleyImprovementOperator.cs	(revision 7775)
+++ branches/ScatterSearch/HeuristicLab.Algorithms.ScatterSearch/3.3/TestFunctions/TestFunctionsAckleyImprovementOperator.cs	(revision 7775)
@@ -0,0 +1,48 @@
+﻿#region License Information
+/* HeuristicLab
+ * Copyright (C) 2002-2012 Heuristic and Evolutionary Algorithms Laboratory (HEAL)
+ *
+ * This file is part of HeuristicLab.
+ *
+ * HeuristicLab is free software: you can redistribute it and/or modify
+ * it under the terms of the GNU General Public License as published by
+ * the Free Software Foundation, either version 3 of the License, or
+ * (at your option) any later version.
+ *
+ * HeuristicLab is distributed in the hope that it will be useful,
+ * but WITHOUT ANY WARRANTY; without even the implied warranty of
+ * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
+ * GNU General Public License for more details.
+ *
+ * You should have received a copy of the GNU General Public License
+ * along with HeuristicLab. If not, see <http://www.gnu.org/licenses/>.
+ */
+#endregion
+
+using HeuristicLab.Common;
+using HeuristicLab.Core;
+using HeuristicLab.Persistence.Default.CompositeSerializers.Storable;
+using HeuristicLab.Problems.TestFunctions;
+
+namespace HeuristicLab.Algorithms.ScatterSearch.TestFunctions {
+  /// <summary>
+  /// An operator that improves Ackley test function solutions.
+  /// </summary>
+  [Item("TestFunctionsAckleyImprovementOperator", "An operator that improves Ackley test function solutions.")]
+  [StorableClass]
+  public sealed class TestFunctionsAckleyImprovementOperator : TestFunctionsImprovementOperator {
+    [StorableConstructor]
+    private TestFunctionsAckleyImprovementOperator(bool deserializing) : base(deserializing) { }
+    private TestFunctionsAckleyImprovementOperator(TestFunctionsAckleyImprovementOperator original, Cloner cloner) : base(original, cloner) { }
+    public TestFunctionsAckleyImprovementOperator() : base() { }
+
+    public override IDeepCloneable Clone(Cloner cloner) {
+      return new TestFunctionsAckleyImprovementOperator(this, cloner);
+    }
+
+    public override IOperation Apply() {
+      FunctionEvaluator = x => { return AckleyEvaluator.Apply(x); };
+      return base.Apply();
+    }
+  }
+}
Index: branches/ScatterSearch/HeuristicLab.Algorithms.ScatterSearch/3.3/TestFunctions/TestFunctionsBealeImprovementOperator.cs
===================================================================
--- branches/ScatterSearch/HeuristicLab.Algorithms.ScatterSearch/3.3/TestFunctions/TestFunctionsBealeImprovementOperator.cs	(revision 7775)
+++ branches/ScatterSearch/HeuristicLab.Algorithms.ScatterSearch/3.3/TestFunctions/TestFunctionsBealeImprovementOperator.cs	(revision 7775)
@@ -0,0 +1,48 @@
+﻿#region License Information
+/* HeuristicLab
+ * Copyright (C) 2002-2012 Heuristic and Evolutionary Algorithms Laboratory (HEAL)
+ *
+ * This file is part of HeuristicLab.
+ *
+ * HeuristicLab is free software: you can redistribute it and/or modify
+ * it under the terms of the GNU General Public License as published by
+ * the Free Software Foundation, either version 3 of the License, or
+ * (at your option) any later version.
+ *
+ * HeuristicLab is distributed in the hope that it will be useful,
+ * but WITHOUT ANY WARRANTY; without even the implied warranty of
+ * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
+ * GNU General Public License for more details.
+ *
+ * You should have received a copy of the GNU General Public License
+ * along with HeuristicLab. If not, see <http://www.gnu.org/licenses/>.
+ */
+#endregion
+
+using HeuristicLab.Common;
+using HeuristicLab.Core;
+using HeuristicLab.Persistence.Default.CompositeSerializers.Storable;
+using HeuristicLab.Problems.TestFunctions;
+
+namespace HeuristicLab.Algorithms.ScatterSearch.TestFunctions {
+  /// <summary>
+  /// An operator that improves Beale test function solutions.
+  /// </summary>
+  [Item("TestFunctionsBealeImprovementOperator", "An operator that improves Beale test function solutions.")]
+  [StorableClass]
+  public sealed class TestFunctionsBealeImprovementOperator : TestFunctionsImprovementOperator {
+    [StorableConstructor]
+    private TestFunctionsBealeImprovementOperator(bool deserializing) : base(deserializing) { }
+    private TestFunctionsBealeImprovementOperator(TestFunctionsBealeImprovementOperator original, Cloner cloner) : base(original, cloner) { }
+    public TestFunctionsBealeImprovementOperator() : base() { }
+
+    public override IDeepCloneable Clone(Cloner cloner) {
+      return new TestFunctionsBealeImprovementOperator(this, cloner);
+    }
+
+    public override IOperation Apply() {
+      FunctionEvaluator = x => { return BealeEvaluator.Apply(x); };
+      return base.Apply();
+    }
+  }
+}
Index: branches/ScatterSearch/HeuristicLab.Algorithms.ScatterSearch/3.3/TestFunctions/TestFunctionsBoothImprovementOperator.cs
===================================================================
--- branches/ScatterSearch/HeuristicLab.Algorithms.ScatterSearch/3.3/TestFunctions/TestFunctionsBoothImprovementOperator.cs	(revision 7775)
+++ branches/ScatterSearch/HeuristicLab.Algorithms.ScatterSearch/3.3/TestFunctions/TestFunctionsBoothImprovementOperator.cs	(revision 7775)
@@ -0,0 +1,48 @@
+﻿#region License Information
+/* HeuristicLab
+ * Copyright (C) 2002-2012 Heuristic and Evolutionary Algorithms Laboratory (HEAL)
+ *
+ * This file is part of HeuristicLab.
+ *
+ * HeuristicLab is free software: you can redistribute it and/or modify
+ * it under the terms of the GNU General Public License as published by
+ * the Free Software Foundation, either version 3 of the License, or
+ * (at your option) any later version.
+ *
+ * HeuristicLab is distributed in the hope that it will be useful,
+ * but WITHOUT ANY WARRANTY; without even the implied warranty of
+ * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
+ * GNU General Public License for more details.
+ *
+ * You should have received a copy of the GNU General Public License
+ * along with HeuristicLab. If not, see <http://www.gnu.org/licenses/>.
+ */
+#endregion
+
+using HeuristicLab.Common;
+using HeuristicLab.Core;
+using HeuristicLab.Persistence.Default.CompositeSerializers.Storable;
+using HeuristicLab.Problems.TestFunctions;
+
+namespace HeuristicLab.Algorithms.ScatterSearch.TestFunctions {
+  /// <summary>
+  /// An operator that improves Booth test function solutions.
+  /// </summary>
+  [Item("TestFunctionsBoothImprovementOperator", "An operator that improves Booth test function solutions.")]
+  [StorableClass]
+  public sealed class TestFunctionsBoothImprovementOperator : TestFunctionsImprovementOperator {
+    [StorableConstructor]
+    private TestFunctionsBoothImprovementOperator(bool deserializing) : base(deserializing) { }
+    private TestFunctionsBoothImprovementOperator(TestFunctionsBoothImprovementOperator original, Cloner cloner) : base(original, cloner) { }
+    public TestFunctionsBoothImprovementOperator() : base() { }
+
+    public override IDeepCloneable Clone(Cloner cloner) {
+      return new TestFunctionsBoothImprovementOperator(this, cloner);
+    }
+
+    public override IOperation Apply() {
+      FunctionEvaluator = x => { return BoothEvaluator.Apply(x); };
+      return base.Apply();
+    }
+  }
+}
Index: branches/ScatterSearch/HeuristicLab.Algorithms.ScatterSearch/3.3/TestFunctions/TestFunctionsGriewankImprovementOperator.cs
===================================================================
--- branches/ScatterSearch/HeuristicLab.Algorithms.ScatterSearch/3.3/TestFunctions/TestFunctionsGriewankImprovementOperator.cs	(revision 7775)
+++ branches/ScatterSearch/HeuristicLab.Algorithms.ScatterSearch/3.3/TestFunctions/TestFunctionsGriewankImprovementOperator.cs	(revision 7775)
@@ -0,0 +1,48 @@
+﻿#region License Information
+/* HeuristicLab
+ * Copyright (C) 2002-2012 Heuristic and Evolutionary Algorithms Laboratory (HEAL)
+ *
+ * This file is part of HeuristicLab.
+ *
+ * HeuristicLab is free software: you can redistribute it and/or modify
+ * it under the terms of the GNU General Public License as published by
+ * the Free Software Foundation, either version 3 of the License, or
+ * (at your option) any later version.
+ *
+ * HeuristicLab is distributed in the hope that it will be useful,
+ * but WITHOUT ANY WARRANTY; without even the implied warranty of
+ * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
+ * GNU General Public License for more details.
+ *
+ * You should have received a copy of the GNU General Public License
+ * along with HeuristicLab. If not, see <http://www.gnu.org/licenses/>.
+ */
+#endregion
+
+using HeuristicLab.Common;
+using HeuristicLab.Core;
+using HeuristicLab.Persistence.Default.CompositeSerializers.Storable;
+using HeuristicLab.Problems.TestFunctions;
+
+namespace HeuristicLab.Algorithms.ScatterSearch.TestFunctions {
+  /// <summary>
+  /// An operator that improves Griewank test function solutions.
+  /// </summary>
+  [Item("TestFunctionsGriewankImprovementOperator", "An operator that improves Griewank test function solutions.")]
+  [StorableClass]
+  public sealed class TestFunctionsGriewankImprovementOperator : TestFunctionsImprovementOperator {
+    [StorableConstructor]
+    private TestFunctionsGriewankImprovementOperator(bool deserializing) : base(deserializing) { }
+    private TestFunctionsGriewankImprovementOperator(TestFunctionsGriewankImprovementOperator original, Cloner cloner) : base(original, cloner) { }
+    public TestFunctionsGriewankImprovementOperator() : base() { }
+
+    public override IDeepCloneable Clone(Cloner cloner) {
+      return new TestFunctionsGriewankImprovementOperator(this, cloner);
+    }
+
+    public override IOperation Apply() {
+      FunctionEvaluator = x => { return GriewankEvaluator.Apply(x); };
+      return base.Apply();
+    }
+  }
+}
